
import random

class player():
        def __init__(self, name, knows, options, weights, game=None):
                self.knows = knows
                self.options = options
                self.weights = weights
                self.game = game
                self.forced_choice = None
                self.totalreward = 0
                self.recentreward = 0
                self.name = name
                self.exploits = 0                
                self.flipped_game = 0
                self.flipped_tourney = 0
                self.game_count = 0
                self.tourney_count = 0

        def choose(self):
                if self.forced_choice:
                        if self.forced_choice == 2:
                                self.exploits = self.exploits + 2
                        if self.forced_choice == 3:
                                self.exploits = self.exploits + 1
                        return self.forced_choice
                randvalue = random.uniform(0,1)
                weight = self.weights[0]
                for i in range(0,len(self.options)):
                        if randvalue <= weight:
                                choice = self.options[i]
                                if choice == 2:
                                        self.exploits = self.exploits + 2
                                if choice == 3:
                                        self.exploits = self.exploits + 1
                                return choice
                        weight = weight + self.weights[i+1]

        def setgame(self, game):
                self.game = game

        def payout(self, value):
                self.recentreward = value
                self.totalreward = self.totalreward + value

        def force_choice(self, choice):
                self.forced_choice = choice

class game():
        def __init__(self, players, options, payouts):
                self.options = options
                self.payouts = payouts
                self.players = players

        def step(self):
                choices = []
                for i in self.players:
                        choices.append(i.choose())
                p = self.retrieve_payouts(choices)
                return [choices, p]

        def play(self):
                #modify for multi step games
                return self.step()

        def retrieve_payouts(self, choices):
                p = self.payouts
#                print "choices"  + str(choices)
                for c in choices:
                        p = p[c-1]
                for j in range(0, len(self.players)):
                        self.players[j].payout(p[j])
                        self.players[j].game_count = 1 + self.players[j].game_count
#                print "players" + str([x.name for x in self.players])
#                print "payouts"  + str(p)
                return p

class group():
        def __init__(self, players, probability):
                self.players = players
                self.propagate_prob = probability

        def update_known(self,iteration,tourney):
                count = 0
                for p in self.players:
                        count = count + p.exploits
                for p in self.players:
                        if not p.knows:
                                for i in range(0,count):
                                        if random.uniform(0,1) < self.propagate_prob:
                                                p.knows = True
                                                w = random.uniform(0,1)
                                                p.weights = [0,w,1-w,0]
                                                p.flipped_game = iteration
                                                p.flipped_tourney = tourney
        def clear_counts(self):
                for p in self.players:
                        p.exploits = 0

class tourney():
        def __init__(self, group, game):
                self.group = group
                self.game = game

        def play(self,rounds,tourney_number):
                for i in range(0,rounds):
                        for j in range(0,len(self.group.players)):
                                for l in range(j+1,len(self.group.players)):
                                        #modify for multi-player
                                        players = [self.group.players[j],self.group.players[l]]
                                        self.game.players = players
                                        results = self.game.play()
                        self.group.update_known(i+1,tourney_number)
                        self.group.clear_counts()
                for p in self.group.players:
                        p.tourney_count = p.tourney_count + 1

class world():
        def __init__(self, players, groupsize, tourneys, tourney_rounds, propagate_prob, game):
                self.groupsize = groupsize
                self.tourneys = tourneys
                self.players = players
                self.game = game
                self.prob = propagate_prob
                self.tourney_rounds = tourney_rounds
                self.tourney_count = 0

        def start(self):
                for j in range(0, self.tourneys):
                        poss_players = list(self.players)
                        self.tourney_count = self.tourney_count + 1
                        for l in range(0,len(self.players)/self.groupsize):
                                grpmembers = []
                                for i in range(0,self.groupsize):
                                        plr = random.choice(poss_players)
                                        grpmembers.append(plr)
                                        poss_players.remove(plr)
                                gr = group(grpmembers, self.prob)
                                t = tourney(gr,self.game)
                                t.play(self.tourney_rounds,self.tourney_count)

def __main__(unknowing, indesc, as_needed, prob, groupsize = 6, tourneys = 20, rounds = 10):
        count = 0
        players = []
        for k in range(0,indesc):
                count = count + 1
                players.append(player('p'+str(count),True, [1,2,3,4],[0,1,0,0],None))
        for k in range(0,as_needed):
                count = count + 1
                players.append(player('p'+str(count),True, [1,2,3,4],[0,0,1,0],None))
        for k in range(0,unknowing):
                count = count +1
                players.append(player('p'+str(count),False, [1,2,3,4],[0,0,0,1],None))
        payoffs = [[[0,0],[0,0],[0,0],[0,0]],#law
                [[0,0],[0,0],[2,-2],[5,-5]],#1ndiscriminant
                [[0,0],[-2,2],[0,0],[3,-3]],#only as needed
                [[0,0],[-5,5],[-3,3],[0,0]]]#never

        if ((unknowing + indesc + as_needed) % groupsize !=0)
                except
        ga = game(None,[1,2,3,4],payoffs)
        w = world(players, groupsize, tourneys, rounds, prob, ga)
        w.start()
        c = 0
        for p in w.players:
                c = c + 1
                print p.name + ": " + str(p.totalreward)+ ": " + str(p.knows) + ": " + str(p.flipped_tourney)+ ": " + str(p.game_count)+ ": " + str(p.tourney_count) + ": " + str(p.weights)

